// ribocore
// code by jph

class aniProbe : public animated {
  public:
    aniProbe(void);
    aniProbe(float R,float G,float B);
    void draw(void);        
    float R,G,B;    
};

aniProbe::aniProbe(void) : animated() {	  
  R=1;
  G=0;
  B=0;  
};

aniProbe::aniProbe(float R,float G,float B) : animated() {	
  this->R=R; this->G=G; this->B=B;  
};

void aniProbe::draw(void) {  
  char glt[80];  
  matrix<double> tmp;
  glPushMatrix(); // OBJECT COORDINATES
    glMultMatrixd(pos.data);
    glPushMatrix();
      glScaled(e1,e2,e3);
      glLineWidth(1);
      glColor3f(R,G,B);  
      glutSolidSphere(0.99,50,50);      
      glColor3f(0,0,0);
      glRotatef(90,1,0,0);
      glutWireSphere(1.05,10,10);
    glPopMatrix();
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_LIGHTING);    
#ifndef NOLINES
    glLineWidth(2);
    glBegin(GL_LINES);
      glColor3f(0,1,1); glVertex3f(0,0,0); glVertex3dv(ome.data);            
    glEnd();
#endif
  glPopMatrix();
#ifndef NOLINES
  glPushMatrix(); // WORLD COORDINATES
    glTranslated(pos.data[12],pos.data[13],pos.data[14]);
    glLineWidth(2);
    glBegin(GL_LINES);      
      glColor3f( 0,.7, 0); glVertex3f(0,0,0); glVertex3dv(ini_vel.data);      
      glColor3f( 0, 1, 0); glVertex3f(0,0,0); glVertex3dv(vel.data);      
      glColor3f(.7,.7, 0); glVertex3f(0,0,0); glVertex3dv(ini_ang.data);      
      glColor3f( 1, 1, 0); glVertex3f(0,0,0); glVertex3dv((pos*ine*ome).data);      
    glEnd();
  glPopMatrix();
#endif
  glEnable(GL_LIGHTING);
  glEnable(GL_DEPTH_TEST);
#ifndef RELEASE_MODE
  tmp=Mrot();
  sprintf(glt,"Irt %5.2f %5.2f %5.2f",tmp.data[0],tmp.data[1],tmp.data[2]);
	linked_label.append(new glLabelText(200,frame_h-11-11*index,glt,fnt0));
  tmp=Mkin();
  sprintf(glt,"kin %5.2f %5.2f %5.2f",tmp.data[0],tmp.data[1],tmp.data[2]);
	linked_label.append(new glLabelText(200,frame_h-44-11*index,glt,fnt0));
#endif  
};
