#ifndef _JGLLABEL_HPP_
#define _JGLLABEL_HPP_

class glLabelText {
	public:
		glLabelText(int ix,int iy,char *is,array<unsigned char> *ifnt);
		int x,y;		
		char s[80];
		array<unsigned char> *fnt;
};

glLabelText::glLabelText(int ix,int iy,char *is,array<unsigned char> *ifnt) {
	x=ix; y=iy; strcpy(s,is); fnt=ifnt;}

class glLabel {
	public:
		glLabel(void);
		~glLabel(void);
		void space(float *pos,char *s,array<unsigned char> *fnt);
		void flush(void);
	bstree<float,glLabelText*> bstree_label;
};

linked<glLabelText*> linked_label;

bool glDrawString(glLabelText *label) {
	int x=label->x;
	int inc=label->fnt->size[0]*label->fnt->size[1]*label->fnt->size[2];
	for (int c1=0;c1<strlen(label->s);c1++) {
		glRasterPos2i(x,label->y); x+=label->fnt->size[2];
		glDrawPixels(label->fnt->size[2],label->fnt->size[1],GL_RGBA,GL_UNSIGNED_BYTE,&(label->fnt->data[(label->s[c1]-32)*inc]));
	};
	return true;
};

glLabel::glLabel(void) {
	bstree_label=bstree<float,glLabelText*>(0,NULL);
}
glLabel::~glLabel(void) {};

void glLabel::space(float *pos,char *s,array<unsigned char> *fnt) {
	float m[16],d;
	matrix<float> w(4,4,""),p(4,1,""),r;
	glGetFloatv(GL_MODELVIEW_MATRIX,m);
	memcpy(w.data,m,4*16);
	memcpy(p.data,pos,4*3); p.data[3]=1;
	r=project*w*p;
	if (r.data[3]>.2) {
		d=1/r.data[3];
		r.data[0]*=d;
		r.data[1]*=d;
		if (r.data[0]>-1&&r.data[0]<1&&r.data[1]>-1&&r.data[1]<1)
			bstree_label.insert(r.data[3],new glLabelText((r.data[0]+1)*frame_w2-fnt->size[2]/2,(r.data[1]+1)*frame_h2-fnt->size[1]/2,s,fnt));
	}
};

//draws strings from back to front
void glLabel::flush(void) {
	int c1,x;
	glLabelText *label;
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);
	glMatrixMode(GL_PROJECTION);	
	glPushMatrix();
		glLoadIdentity();		
		gluOrtho2D(0,frame_w,0,frame_h);
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();		
			glLoadIdentity();
			while (linked_label.token(label)) {
				glDrawString(label);
				delete label;
				linked_label.remove();
			}			
			if (bstree_label.next[1])	
				((bstree<float,glLabelText*>*)bstree_label.next[1])->inorder(glDrawString);
			bstree_label.destruct();
		glPopMatrix();
		glMatrixMode(GL_PROJECTION);
	glPopMatrix();	
	glMatrixMode(GL_MODELVIEW);
	glDisable(GL_BLEND);
	//glBlendFunc(GL_SRC_ALPHA,GL_ONE);
};

template <class type> void glPlotArray(int y,array<type>* a,float amp,float r,float g,float b) {
	glMatrixMode(GL_PROJECTION);	
	glPushMatrix();
		glLoadIdentity();		
		gluOrtho2D(0,frame_w,0,frame_h);
		glMatrixMode(GL_MODELVIEW);
		glPushMatrix();
			glLoadIdentity();
			glColor3f(r,g,b);
			glPointSize(2);
			glBegin(GL_POINTS);
				for (int c1=0;c1<a->numel;c1++) glVertex2i(c1,y+(int)(a->data[c1]*amp));
			glEnd();
		glPopMatrix();
		glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
}

#endif