// ribocore
// code by jph

#include <windows.h>
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <iostream.h>
#include "ntree.hpp"
#include "matrix.hpp"

//#define RELEASE_MODE

#define KEY_ST     0
#define KEY_SP     256
#define KEY_DOWN   512
#define KEY_MODIFY 256*4
#define KEY_left   KEY_SP+100
#define KEY_right  KEY_SP+102
#define KEY_up     KEY_SP+101
#define KEY_down   KEY_SP+103

#define FRUSTUM    3000
#define RECFRAME   5
#define RECTOTAL   30

int tic=0,toc,frames,ftic;
#ifndef RELEASE_MODE
int frame_w=460,frame_h=306;
#else
int frame_w=230,frame_h=153;
#endif

int frame_v,frame_w2,frame_h2;
long frame_c=0;

matrix<float> project(4,4,"");
matrix<int> keys(256,6,"");
int mouse[7];
bool fscreen=false,modes[4];
array<unsigned char> *fnt0; //courier 7x11 bold
static int shot_cnt=0,tri_cnt=0;

#include "jglLabel.hpp"
glLabel glCout;

void main_ (int argc,char** argv);
void display_ (void);
void drawOneString(int x,int y,char *txt); //we dont need that?

void display(void) {	  
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	toc=clock(); frames++;
	if (ftic+1000<toc) {ftic=toc; frame_v=frames; frames=0;}	
	char dtc[10];
#ifndef RELEASE_MODE	
	sprintf(dtc,"%i",frame_v);
	linked_label.append(new glLabelText(0,0,dtc,fnt0));	
#endif
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	display_();
	glCout.flush();
	if (keys.data[27]) exit(0);
	if (keys.data[103]) {//opengl control mode
		if (keys.data[102+KEY_DOWN]) //flat shade
			if (modes[1])  {modes[1]=false; glShadeModel(GL_SMOOTH);}
								else {modes[1]=true;  glShadeModel(GL_FLAT);};
		if (keys.data[115+KEY_DOWN]) {//saving
			int size[3];
			size[0]=4; size[1]=frame_w; size[2]=frame_h;
			array<unsigned char> rgba(3,size,0);
			glReadPixels(0,0,frame_w,frame_h,GL_RGBA,GL_UNSIGNED_BYTE,rgba.data);
			char fnc[60];
			sprintf(fnc,"data/pixels%i.rgba",shot_cnt); rgba.store(fnc);
			array<float> depth(2,&size[1],0);
			glReadPixels(0,0,frame_w,frame_h,GL_DEPTH_COMPONENT,GL_FLOAT,depth.data);
			sprintf(fnc,"data/pixels%i.depth",shot_cnt); depth.store(fnc);			
			shot_cnt++;
		}
		if (keys.data[119+KEY_DOWN]) //wireframe
			if (modes[0])  {modes[0]=false; glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);}
								else {modes[0]=true;  glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);};
	}
#ifdef RELEASE_MODE
	if (!(frame_c%RECFRAME)&&frame_c<RECFRAME*RECTOTAL) {
		int size[3];
		size[0]=4; size[1]=frame_w; size[2]=frame_h;
		array<unsigned char> rgba(3,size,0);
		glReadPixels(0,0,frame_w,frame_h,GL_RGBA,GL_UNSIGNED_BYTE,rgba.data);		
		char fnc[60];
		sprintf(fnc,"out/shot%i.rgba",100+frame_c/RECFRAME);
		rgba.store(fnc);
	}
#endif
	glFlush();
	glutSwapBuffers();
	memset(&keys.data[KEY_ST+KEY_DOWN],0,1024);
	memset(&keys.data[KEY_SP+KEY_DOWN],0,1024);
	frame_c++;
};

void redisplay(void) {glutPostRedisplay();}
void keyboard(unsigned char key,int x,int y) {	
	int m=glutGetModifiers();	
	keys.data[key+KEY_ST]=1;
	keys.data[key+KEY_ST+KEY_DOWN]=1;
	keys.data[key+KEY_MODIFY]=m;		
	printf("down %i %i\n",key,m);
};
void keyboardUp(unsigned char key,int x,int y) {	
	if (key==27) exit(0);	
	keys.data[key+KEY_ST]=0;
	keys.data[key+KEY_MODIFY]=0;	
};
void special(int key,int x,int y) {	
	int m=glutGetModifiers();
	keys.data[key+KEY_SP]=1;
	keys.data[key+KEY_SP+KEY_DOWN]=1;
	keys.data[key+KEY_SP+KEY_MODIFY]=m;	
	printf("spec %i %i\n",key,m);
};
void specialUp(int key,int x,int y) {
	keys.data[key+KEY_SP]=0;
	keys.data[key+KEY_SP+KEY_MODIFY]=0;
};
void mousefunc(int b,int s,int x,int y) {
	int c1;
	if (b==0)
		if (s==0)	{
			mouse[0]=0; //delta
			mouse[1]=0;
			mouse[2]=y; //actual
			mouse[3]=x;
			mouse[4]=y; //mouse offset
			mouse[5]=x;
			mouse[6]=1;}
		else
			for (c1=0;c1<7;c1++) mouse[c1]=0;
};
void motion(int x,int y) {	
	if (mouse[6]) {
		mouse[0]=y-mouse[2];
		mouse[1]=x-mouse[3];
		mouse[2]=y;
		mouse[3]=x;};
};
void passivemotion(int x,int y) {};
void entry(int s) {
#ifndef RELEASE_MODE
	if (!s) exit(0);
#endif
};
void reshape(int framew,int frameh) {	
	float p[16];
	frame_w =framew;		frame_h =frameh;	
	frame_w2=framew*.5; frame_h2=frameh*.5;
	glViewport (0,0,frame_w,frame_h);
	glMatrixMode(GL_PROJECTION);						//matrices
		glLoadIdentity();
		glPushMatrix();
		  gluPerspective(55,frame_w/(float)frame_h,.1,FRUSTUM);
		  glGetFloatv(GL_PROJECTION_MATRIX,p);
		  memcpy(project.data,p,4*16);				  
		glPopMatrix();
		glMultMatrixf(project.data);
	display();
};
int main(int argc,char** argv) {
	int c1;	
#ifdef	BIGWINDOW
frame_w=460;
frame_h=306;
#endif
	glutInit(&argc,argv);										//opengl window
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_DEPTH|GLUT_RGBA);	
	if (!fscreen) {
		glutInitWindowPosition(700,20);
		glutInitWindowSize(frame_w,frame_h);
		glutCreateWindow("virtual world");
	} else {
		glutGameModeString("1152x864:32@75");
		if (glutGameModeGet(GLUT_GAME_MODE_POSSIBLE)) glutEnterGameMode();
	};
	glutDisplayFunc(display);								//callbacks
		glutIdleFunc(redisplay);
		glutKeyboardFunc(keyboard);
		glutKeyboardUpFunc(keyboardUp);
		glutSpecialFunc(special);
		glutSpecialUpFunc(specialUp);
		glutMouseFunc(mousefunc);
		glutMotionFunc(motion);
		glutPassiveMotionFunc(passivemotion);
		glutEntryFunc(entry);
		glutReshapeFunc(reshape);
		glutIgnoreKeyRepeat(1);	
	glMatrixMode(GL_PROJECTION);						//matrices
		gluPerspective(55,1.5,.1,FRUSTUM);					
	glShadeModel(GL_SMOOTH);							//GL_FLAT
	glEnable(GL_DEPTH_TEST);							//depthtest
		glDepthFunc(GL_LESS);	
	
	glPixelStorei(GL_UNPACK_ALIGNMENT,1);     //texture
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);		
	//glEnable(GL_LINE_SMOOTH); glHint(GL_LINE_SMOOTH_HINT,GL_DONT_CARE);
	//glEnable(GL_BLEND);										//blending
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);		
	glDisable(GL_BLEND);										//blending
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);

	float light_col[]={1.,1.,1.,1.},light_amb[]={.3,.3,.3,1.};
	glEnable(GL_COLOR_MATERIAL);
	glColorMaterial(GL_LIGHT_MODEL_TWO_SIDE,GL_AMBIENT_AND_DIFFUSE);	
	glLightfv(GL_LIGHT0,GL_DIFFUSE,light_col);
	glLightfv(GL_LIGHT0,GL_SPECULAR,light_col);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT,light_amb);
	glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,1.0);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);		
		
	float fog_color[4]={.15,.15,.15,1};
	//glEnable(GL_FOG);
		glFogfv(GL_FOG_COLOR,fog_color);	
		glFogf(GL_FOG_DENSITY,.005);
	//glEnable(GL_LINE_SMOOTH);
	//glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);
	for (c1=0;c1<7;c1++) mouse[c1]=0;
	//printf("%i",ROUND(-.7)); exit(0);	
	fnt0=new array<unsigned char>("data/courier.fnt");
	main_(argc,argv);
	
	toc=clock();	
	glutMainLoop(); return 0;
}
